`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/07/24 18:00:03
// Design Name: 
// Module Name: VGA_OUT
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module VGA_OUT(
input wire clk,
//input wire rst,
input wire Vsync, Href,
input wire [7:0] Data,
output reg [3:0] VGA_R,
output reg [3:0] VGA_G,
output reg [3:0] VGA_B,
output reg VGA_Vsync,
output reg VGA_Href
    );
    
    
    reg clk_config;  // Image Data 2Ʈ  ޵ǹǷ clk_config reg  RGB 565  ȮϿ óؾ Ѵ.
    reg [15:0] image_data;
    reg start;
    reg clk_divide;
    
    initial begin
        clk_config <= 0;
        image_data <= 0;
        start <= 0;
        clk_divide <= 0;
    end
    

    always@(posedge clk)    begin
      /*  if(!rst)    begin
            VGA_R <= 0;
            VGA_G <= 0;
            VGA_B <= 0;
            VGA_Vsync <= 0;
            VGA_Href <= 0;
        end */
        
        
        clk_divide <= 0;
        VGA_Vsync <= Vsync;
        VGA_Href <= Href;
        clk_config <= ~clk_config;
        if(clk_config == 0) begin   // ʱ 1Ʈ 
          /*  VGA_R[0] <= Data[0];
            VGA_R[1] <= Data[1];
            VGA_R[2] <= Data[2];
            VGA_R[3] <= Data[3];
            
            VGA_G[0] <= Data[5];
            VGA_G[1] <= Data[6];
            VGA_G[2] <= Data[7];
            */
            start <=  0;
            image_data[0] <= Data[0];   //G3
            image_data[1] <= Data[1];   // G4
            image_data[2] <= Data[2];   // G5
            image_data[3] <= Data[3];   // R0
            
            image_data[4] <= Data[4];   // R1
            image_data[5] <= Data[5];   // R2
            image_data[6] <= Data[6];   //R3
            image_data[7] <= Data[7];   // R4
         end
         else   begin               //// ι° Ʈ 
           /* VGA_G[3] <= Data[0];
            
            VGA_B[3] <= Data[3];
            VGA_B[3] <= Data[4];
            VGA_B[3] <= Data[5];
            VGA_B[3] <= Data[6];
            */
            start <= 1;
            image_data[8] <= Data[0];   // B0
            image_data[9] <= Data[1];   // B1
            image_data[10] <= Data[2];  // B2
            image_data[11] <= Data[3];  // B3
            
            image_data[12] <= Data[4];  // B4
            image_data[13] <= Data[5];  // G0
            image_data[14] <= Data[6];  // G1
            image_data[15] <= Data[7];  //G2
         end
         if(start == 1) begin
            VGA_R[0] <= image_data[3];
            VGA_R[1] <= image_data[4];
            VGA_R[2] <= image_data[5];
            VGA_R[3] <= image_data[6];
            
            VGA_G[0] <= image_data[13];
            VGA_G[1] <= image_data[14];
            VGA_G[2] <= image_data[15];
            VGA_G[3] <= image_data[0];
            
            VGA_B[0] <= image_data[8];
            VGA_B[1] <= image_data[9];
            VGA_B[2] <= image_data[10];
            VGA_B[3] <= image_data[11];
          end            
    
    end
endmodule
